import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import { LayerExtension, COORDINATE_SYSTEM } from '@deck.gl/core';
import project64 from './project64';

var Fp64Extension = function (_LayerExtension) {
  _inherits(Fp64Extension, _LayerExtension);

  function Fp64Extension() {
    _classCallCheck(this, Fp64Extension);

    return _possibleConstructorReturn(this, _getPrototypeOf(Fp64Extension).apply(this, arguments));
  }

  _createClass(Fp64Extension, [{
    key: "getShaders",
    value: function getShaders(opts) {
      var coordinateSystem = this.props.coordinateSystem;

      if (coordinateSystem !== COORDINATE_SYSTEM.LNGLAT && coordinateSystem !== COORDINATE_SYSTEM.DEFAULT) {
        throw new Error('fp64: coordinateSystem must be LNGLAT');
      }

      return {
        modules: [project64]
      };
    }
  }]);

  return Fp64Extension;
}(LayerExtension);

export { Fp64Extension as default };
Fp64Extension.extensionName = 'Fp64Extension';
//# sourceMappingURL=fp64.js.map